%% TD 2 de RNA : Regression lineaire et Selection de Variables
%% Auteurs : soizic Geslin et Maxime Chambreuil
%% Date : 10 Fevrier 2003

close all;
clear all;

nbIndividu = 5000;
data = load('comp-activity.data');
nbVar = size(data,2);

%var_restantes = 1:12;
var_restantes = 6;
var_select = [];

%while (length(var_restantes) ~= 0)
    clear R2;
    for var=var_restantes
	
    	[X Y] = extraction(data,var,nbIndividu);
	    % Calcul de regression

     	% On calcule les coefficients
	    A= [];
	    A = (X'*X)\(X'*Y);
        Ychapo = X*A;
	
        % On trace la droite obtenue par la regression lineaire
	    figure(var)
        subplot(4,1,1)
        plot(X(:,1),Y,'g+');
	    hold on;
	    plot(X(:,1),Ychapo,'r');

   	    % On calcule la moyenne et l'ecart-type de l'erreur
	    erreur=Y-Ychapo;
	    moyErreur = mean(erreur,1);
	    varErreur = std(erreur);

        
        % On trace la courbe donnant les intervalles de prediction a 95%
        %t((1-p)/2)=1.96 pour p=95% et n grand (notre cas)
        % std(erreur) : la variance, notee s dans le cours
        xBulle = linspace(min(X(:,1)),max(X(:,1)),nbIndividu);
        diffAuCarreBulle = (xBulle-mean(X(:,1))).*(xBulle-mean(X(:,1)));
        diffAuCarreX = (X(:,1)-mean(X(:,1))).*(X(:,1)-mean(X(:,1)));
        deltaY = 1.96 * std(erreur) * sqrt(1/nbIndividu +  diffAuCarreBulle ./ sum(diffAuCarreX) + 1);
        
        plot(X(:,1),Ychapo'+deltaY,'b')
        plot(X(:,1),Ychapo'-deltaY,'b')

                
        
        
        hold off;
    

	    % On calcule le coefficient de correlation
	    varExpliquee = Ychapo-mean(Y);
	    varPoints = Y-mean(Y);
	    R2(var) = sum(varExpliquee.^2)/sum(varPoints.^2);
	    fprintf('Iteration %d : coefficient R2(var): %f \n',var,R2)
    
        % On trace la courbe residu : y(chapo) - y(reel)
        subplot(4,1,2)
        hold on
        plot(X(:,1),erreur,'r+')
        plot(X(:,1),0)
        hold off
        
        % On trace la courbe y(reel) vs y(chapo)     
        subplot(4,1,3)
        plot(Y,Ychapo,'r+')
        hold on
        plot(Y,Y)
        hold off
    
        
        % On trace la droite de henry pour verifier la normalite de l'erreur
        subplot(4,1,4)
        normplot(erreur)
        
    end
    
    
    [aJeter meilleur_var] = max(R2);
    var_select = [var_select meilleur_var];
    var_restantes = setdiff(var_restantes,meilleur_var);
end

fprintf('Notre classement : \n');
var_select